/*
 * 쐬: 2004/10/24
 *
 */
package jp.starlogic.axistest.logic;

import java.util.List;

import jp.starlogic.axistest.dao.CustomerDao;
import jp.starlogic.axistest.dao.EmployeeDao;
import jp.starlogic.axistest.dao.ProductDao;
import jp.starlogic.axistest.dao.SalesDetailDao;
import jp.starlogic.axistest.dao.SalesHeaderDao;
import jp.starlogic.axistest.vo.Customer;
import jp.starlogic.axistest.vo.Employee;
import jp.starlogic.axistest.vo.MasterInfos;
import jp.starlogic.axistest.vo.Product;
import jp.starlogic.axistest.vo.Sales;
import jp.starlogic.axistest.vo.SalesDetail;
import jp.starlogic.axistest.vo.SalesHeader;

/**
 * @author epsy
 *
 */
public class SalesInnerServiceImpl implements SalesInnerService {
	private CustomerDao customerDao;
	private EmployeeDao employeeDao;
	private ProductDao productDao;
	private SalesDetailDao detailDao;
	private SalesHeaderDao headerDao;
	
	public SalesInnerServiceImpl(SalesHeaderDao headerDao, SalesDetailDao detailDao) {
		this.detailDao = detailDao;
		this.headerDao = headerDao;
	}
	
	

	/**
	 * @param customerDao customerDao ݒB
	 */
	public void setCustomerDao(CustomerDao customerDao) {
		this.customerDao = customerDao;
	}
	/**
	 * @param employeeDao employeeDao ݒB
	 */
	public void setEmployeeDao(EmployeeDao employeeDao) {
		this.employeeDao = employeeDao;
	}
	/**
	 * @param productDao productDao ݒB
	 */
	public void setProductDao(ProductDao productDao) {
		this.productDao = productDao;
	}
	/**
	 *
	 */

	public MasterInfos getMasterInfos() {
		MasterInfos infos = new MasterInfos();
		infos.setCustomers(getCustomers());
		infos.setEmployees(getEmployees());
		infos.setProducts(getProducts());
		return infos;
	}
	
	private Customer[] getCustomers() {
		List list = customerDao.getCustomers();
		return (Customer[]) list.toArray(new Customer[list.size()]);
	}
	
	private Employee[] getEmployees() {
		List list = employeeDao.getEmployees();
		return (Employee[]) list.toArray(new Employee[list.size()]);
	}
	
	private Product[] getProducts() {
		List list = productDao.getProducts();
		return (Product[]) list.toArray(new Product[list.size()]);
	}

	/**
	 *
	 */

	public void insertSales(Sales sales) {
		int id = insertHeader(sales.getHeader());
		insertDetails(id, sales.getDetails());
	}
	
	private int insertHeader(SalesHeader header) {
		int headerId = headerDao.getNextVal();
		header.setId(headerId);
		headerDao.insertSalesHeader(header);
		return headerId;
	}
	
	private void insertDetails(int headerId, SalesDetail[] details) {
		for (int i = 0; i < details.length; i++) {
			int id = detailDao.getNextVal();
			details[i].setId(id);
			details[i].setSalesHeaderId(headerId);
			detailDao.insertSalesDetail(details[i]);
		}
	}

}
