/*
 * 쐬: 2004/10/24
 *
 */
package test.jp.starlogic.axistest.dao;

import java.util.List;

import jp.starlogic.axistest.dao.SalesDetailDao;
import jp.starlogic.axistest.vo.SalesDetail;
import junit.framework.Test;
import junit.framework.TestSuite;

import org.seasar.extension.unit.S2TestCase;

/**
 * @author epsy
 *
 */
public class SalesDetailDaoTest extends S2TestCase {
	private SalesDetailDao dao;

	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		include(DaoAllTests.PATH);
	}

	/**
	 * Constructor for SalesDetailDaoTest.
	 * @param arg0
	 */
	public SalesDetailDaoTest(String arg0) {
		super(arg0);
	}
	
	public static Test suite() {
		return new TestSuite(SalesDetailDaoTest.class);
	}
	
	public void testGetNextVal() {
		int tmp = dao.getNextVal();
		assertEquals("1", tmp + 1, dao.getNextVal());
	}
	
	public void testInsertSalesDetailTx() {
		SalesDetail detail = new SalesDetail();
		int tmp = dao.getNextVal();

		detail.setId(tmp);
		detail.setSalesHeaderId(100);
		detail.setProductId(5);
		detail.setQuantity(10);
		
		
		dao.insertSalesDetail(detail);
		
		SalesDetail retDetail = dao.getSalesDetail(tmp);
		
		assertEquals("1", 100, retDetail.getSalesHeaderId());
		assertEquals("2", 5, retDetail.getProductId());
		
	}
	
	public void testGetSalesDetailsBySalesHeaderIdTx() {
		SalesDetail detail = new SalesDetail();
		detail.setId(1);
		detail.setSalesHeaderId(100);
		detail.setProductId(5);
		detail.setQuantity(10);
		dao.insertSalesDetail(detail);
		
		detail = new SalesDetail();
		detail.setId(2);
		detail.setSalesHeaderId(101);
		detail.setProductId(15);
		detail.setQuantity(110);
		dao.insertSalesDetail(detail);
		
		detail = new SalesDetail();
		detail.setId(3);
		detail.setSalesHeaderId(100);
		detail.setProductId(25);
		detail.setQuantity(210);
		dao.insertSalesDetail(detail);
		
		List list = dao.getDalesDetailsBySalesHeaderId(100);
		assertEquals("1", 2, list.size());
		
	}

	

}
